	.MODEL  small
	.8086
	.STACK  100h

a_offs  EQU     'a'-0ah

	.DATA
startmsg  db      13,10,'keypause.....$'
finmsg    DB      13,10,'finishing',13,10,'$'

mychar  DW      0
savchar DW      0
oldchar DW      0
oldad1  DW      0
oldad2  DW      0

	.CODE
	jmp     start           ;;;; the following are just support 
				;;;; routines, skip down to the program part
doint1:
	mov     ax,5001h
	mov     bh,00h
	int     16h
	mov     [oldchar],bx    ; int 16 return val in bl
	ret

doint2:
	mov     ax,5003h
	mov     bh,00h
	int     16h
	mov     [oldad1],dx     ; int 16 return val in cx,dx
	mov     [oldad2],cx
	ret

;; have a keypress, put it where main loop can find it
myhndlr:
	or      al,al
	je      mhfin
	push    ds
	push    dx
	mov     dx,@data
	mov     ds,dx
	mov     [mychar],ax
	pop     dx
	pop     ds
mhfin:  retf

;; set up myhandlr to be called on a key press
doint3:
	mov     ax,5003h        
	mov     bh,01
	mov     dx,cs
	mov     cx,OFFSET myhndlr
	int     16h
	ret                     ; apparently no return value

doint4:
	mov     ax,5001h
	mov     bh,01h
	mov     bl,01h
	int     16h
	ret                     ; apparently no return value

myint:
	mov     ah,07
	int     21h
	ret
	
;;;;
;;;;  main program starts here
;;;;

start:  mov     dx,@data                ; base or our data space
	mov     ds,dx                   ; into ds

	mov     ah,9
	mov     dx,offset startmsg
	int     21h

	call    doint1                  ; apparently these set things up
	call    doint2                  ; for what we are about to do
	call    doint3
	call    doint4

	mov     ax,0
	mov     [mychar],ax
dlp:    mov     ax,[mychar]
	or      ax,ax
	je      dlp

	and     ax,2
	push    ax

;; make everything nice and go back to wherever we were before
fin:
	stc
	push    dx
	pushf
	mov     dx,[oldad1]
	mov     cx,[oldad2]
	mov     bh,01
	mov     ax,5003h
	int     16h
	popf
	pop     dx
	
	mov     dx,OFFSET finmsg
	mov     ah,09
	int     21h

	pop     ax
	mov     ah,4ch
	int     21h

END

